/*
 * Copyright 2016 by Kappich Systemberatung Aachen
 * 
 * This file is part of de.bsvrz.dua.tests.
 * 
 * de.bsvrz.dua.tests is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * de.bsvrz.dua.tests is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with de.bsvrz.dua.tests.  If not, see <http://www.gnu.org/licenses/>.

 * Contact Information:
 * Kappich Systemberatung
 * Martin-Luther-Straße 14
 * 52062 Aachen, Germany
 * phone: +49 241 4090 436 
 * mail: <info@kappich.de>
 */

package de.bsvrz.dua.tests;

import com.google.common.collect.ImmutableList;
import de.bsvrz.dav.daf.main.Data;
import de.bsvrz.dav.daf.main.DataDescription;
import de.bsvrz.dav.daf.main.config.SystemObject;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.NoSuchElementException;

/**
 * TBD Dokumentation
 *
 * @author Kappich Systemberatung
 */
public abstract class ColumnLayout {
	public abstract int getColumnCount(final boolean in);

	public abstract void setValues(final SystemObject testObject, Data item, List<String> row, int realCol, final String type, final boolean in);

	public List<Data> getSubDatas(String type, final Data data) {
		try {
			return ImmutableList.of(data.getItem(type));
		}
		catch(NoSuchElementException ignored){
			return ImmutableList.of();
		}
	}

	public Collection<String> getIgnored() {
		return Collections.emptySet();
	}
	
	public Collection<String> getIgnoredLines() {
		return Collections.emptySet();
	}

	public String getExpectedMessageText(final List<String> fullRow, final DataDescription dataDescription, final List<List<String>> header, final long timestamp){
		return null;
	}

	public int getOutOffset() {
		return 0;
	}

	public long getIntervallLength() {
		return 60000;
	}

	public boolean groupingEnabled() {
		return true;
	}
}

